'
' Morsebake fr max. 63 Zeichen Speichertext
' Der Text wird ber die serielle Schnittstelle (9600 bit/s) eingeschrieben; so lsst sich der Bakentext ndern,
' ohne den ATtiny neu flashen zu mssen. Der Text wird im EEprom gespeichert.
'
' Pin PB0 wird als Timer0-Ausgang OC0A verwendet, Ton wird durch Umschalten des Pins als Eingang / Ausgang ein- und
' ausgeschaltet.
'
' Liegt beim Einschalten ein "High" an PB0 (Auswertung des DTR- Signals des Terminalprogramms), startet der Speicher-
' einschreibmodus. Daher ist ein externer Pulldown-Widerstand an PB0 erforderlich
'
' PB3 wird als Keyer- Ausgang verwendet.
' PB4 schaltet PTT bzw. die Stromversorgung fr den Sender
'
' Pin PB1 und PB2 bilden einen Software- UART (eingegebene Zeichen werden als Echo auf das Terminal zurckgesendet)
'
' Der Bascom- Software- UART hat keinen Zeichenpuffer; die Zeichen drfen nicht zu schnell eingeschrieben werden
'
' Bei 4a hinzugekommen: Terminal- Dialog
' Bei 4b: Datazeilen einsparen
' Bei 5 hinzugekommen: Speed-Abfrage   1 ... 9    45 zpm ... 100 Zpm

'------------------------------------------------------------------------------



$regfile = "ATtiny13.dat"
$crystal = 1200000
$hwstack = 8                                                ' reicht fr 4 Unterprogramme, spart SRAM
$swstack = 0                                                ' wird nicht gebraucht, spart SRAM
$framesize = 0                                              ' dito


Dim I As Byte                                               'Fr temporren Gebrauch als Schleifenzhler
Dim N As Byte
Dim Recbyte As Byte
Dim M As Byte                                               ' Index des aktuellen Morsebuchstabens in unserer Tabelle
Dim L As Byte                                               ' fr niederwertigstes Bit beim bitweisen Erzeugen des Morsezeichens

Dim Punktlaenge As Word
Dim Strichlaenge As Word
Dim Wortpause As Word

Const Tonhoehe = 20                                         ' Tonhhe


' Morseton mit Timer0 erzeugen:
'
' Timer0 zhlt das Register TCNT0 hoch. Es wird mit Register OCR0A verglichen.
' Wenn TCNT0 = OCR0A, wird Output OC0A/PB0 umgeschaltet (getoggled)
' Timer0 erzeugt so Dauerton; er wird jedoch nur an den Ausgangspin durchgeschaltet,
' wenn das Datenrichtungs- Register DDRB.0 = 1 ist. Bei 0 wird der Ton unterdrckt.
'

Config Timer0 = Counter , Prescale = 64 , Compare A = Toggle , Clear Timer = 1
Ocr0a = Tonhoehe

Acsr.acd = 1                                                ' Analog-Komparator ausschalten, spart etwas Strom
Portb = &B00000010                                           ' PB1 Pullup, PB0 Eingang ohne Pullup (externer Pulldown)
Ddrb = &B00011000                                           ' PB3 und PB4 Ausgang; Rest Eingang


Open "comb.2:9600,8,n,1,inverted" For Input As #1           ' Software- UART Input an PortB.2
Open "comb.1:9600,8,n,1,inverted" For Output As #2          ' Software- UART Output an PortB.1


'------------------------------------------------------------------------------


Main:

 If Pinb.0 = 1 Then                                         ' ser. Schnittstelle angeschlossen, DTR = High
    Print #2 , "Speed (1-9), dann Bakentext. Ende mit <Return>"
    For N = 0 To 63
       Get #1 , Recbyte                                     ' einlesen
       Put #2 , Recbyte                                     ' Echo auf Terminal zurcksenden
       Writeeeprom Recbyte , N
       If Recbyte = 13 Then
          Exit For
       End If
    Next
 End If

 Readeeprom I , 0                                           ' 48 ....57
 Punktlaenge = 63 - i                                       ' 15 ... 6
 Shift Punktlaenge , Left , 3                               ' entspricht *8
 Strichlaenge = Punktlaenge
 Shift Strichlaenge , Left , 1                              ' entspricht *2
 Strichlaenge = Strichlaenge + Punktlaenge                  ' nun *3
 Wortpause = Punktlaenge
 Shift Wortpause , Left , 2                                 ' enstpricht *4
 Wortpause = Wortpause + Punktlaenge                        ' nun *5


 Do

      Portb.4 = 1                                           ' Stromversorgung Sender an
      Ddrb.0 = 1                                            ' Ton an
      Portb.3 = 1                                           ' PTT an
      Wait 3                                                ' Dauerton 3 sec
      Ddrb.0 = 0                                            ' Ton aus
      Portb.3 = 0
      Wait 1

      For N = 1 To 63                                       ' max. Msg_laenge 63
         Readeeprom Recbyte , N
         If Recbyte = 13 Then
            Exit For
         End If
         If Recbyte > 90 Then                               ' in Kleinbuchstaben wandeln
             Recbyte = Recbyte - 32
         End If
         Recbyte = Recbyte - 32                             ' Morsetabelle faengt ert bei 32 an
         M = Lookup(recbyte , Morsetabelle)                 ' Morsezeichen aus Tabelle holen
         Gosub Morse
      Next N


      Portb.4 = 0                                           ' Stromversorgung Sender aus
      Wait 10                                               ' Pause

 Loop


 Morse:

      If M = 0 Then                                         ' Sonderfall: Leerzeichen;
         Waitms Wortpause
         Goto Zeichenende
      End If

      For I = 1 To 8
        If M = 1 Then                                       ' Das Byte hat nur noch den Wert 1; Zeichenende!
           Goto Zeichenende
        End If
        L = M And &B00000001                                ' niederwertigstes Bit lesen
          Ddrb.0 = 1
          Portb.3 = 1
        If L = 1 Then
           Waitms Strichlaenge                              ' ist das Bit 1 -> dah
          Else
           Waitms Punktlaenge                               ' ist das Bit 0 -> dit
        End If
         Ddrb.0 = 0
         Portb.3 = 0
        Waitms Punktlaenge                                  ' Pause innerhalb des Morsezeichens
        Shift M , Right , 1                                 ' Bits um eine Stelle nach rechts shiften
      Next I

     Zeichenende:
     Waitms Strichlaenge                                    ' Pause zwischen Morsezeichen

 Return

End


'------------------------------------------------------------------------------

Morsetabelle:


' Ascii 32 - 47   ->   _!"#$%&'()*+,-./
Data 0 , 0 , &B01010010 , 0 , 0 , 0 , &B00101010 , 0 , &B00101101 , &B01101101 , 0 , &B00101010 , &B01110011 , &B01100001
Data &B01101010 , &B00101001

' Ascii 48 - 57  ->  0123456789
Data &B00111111 , &B00111110 , &B00111100 , &B00111000 , &B00110000 , &B00100000 , &B00100001 , &B00100011 , &B00100111 , &B00101111

'Ascii 58 - 64  ->  :;<=>?@
Data &B01000111 , &B01110011 , &B00101101 , &B00110001 , &B01101101 , &B01001100 , 0

' Ascii 65 -  90        ABCDEFGHIJKLMNOPQRSTUVWXYZ
Data &B00000110 , &B00010001 , &B00010101 , &B00001001 , &B00000010 , &B00010100 , &B00001011 , &B00010000 , &B00000100
Data &B00011110 , &B00001101 , &B00010010 , &B00000111 , &B00000101 , &B00001111 , &B00010110 , &B00011011 , &B00001010
Data &B00001000 , &B00000011 , &B00001100 , &B00011000 , &B00001110 , &B00011001 , &B00011101 , &B00010011